#ifndef _584BEAD0_FF27_11DC_9F60_001CC417AC4A_ // ---- INCLUDE PROTECTION ----
#define _584BEAD0_FF27_11DC_9F60_001CC417AC4A_ // ---- INCLUDE PROTECTION ----
/** 
 ****************************************************************************
 *
 *
 * @file    ComponentA.hpp
 *
 * @author  Charles Halliday
 *
 * @date    31 Mar 2008
 *
 ****************************************************************************
 */

#include "ComponentABase.hpp"
#include <map>
#include <unistd.h>

#define DO_DEBUG_LOGS 0
#define DEBUG_LOG(str) \
 { \
   if ( DO_DEBUG_LOGS ) { \
     std::cerr << "DEBUG: ComponentA " << getpid() << " " \
               << __FUNCTION__ << "(" << __LINE__ << "): " \
               << str << std::endl; \
   } \
 }
#define DO_INFO_LOGS 1
#define INFO_LOG(str) \
 { \
   if ( DO_INFO_LOGS ) { \
     std::cerr << "INFO: ComponentA " << getpid() << " " \
               << __FUNCTION__ << "(" << __LINE__ << "): " \
               << str << std::endl; \
   } \
 }
#define DO_ERROR_LOGS 1
#define ERROR_LOG(str) \
 { \
   if ( DO_ERROR_LOGS ) { \
     std::cerr << "ERROR: ComponentA " << getpid() << " " \
               << __FUNCTION__ << "(" << __LINE__ << "): " \
               << str << std::endl; \
   } \
 }

namespace com_myco_ComponentA {

  struct ObjectInfo {
    ::com::sun::star::uno::Reference<  ::com::myco::ZInterfaceAListener >
    listener;
    sal_Bool isSet;
  };

  typedef std::map < ::rtl::OUString, struct ObjectInfo > StringObjectInfoMap;

  class ComponentA : public ComponentABase
  {

  public:

    ComponentA( ::com::sun::star::uno::Reference< ::com::sun::star::uno::XComponentContext > const & xComponentContext);

    virtual ~ComponentA();

    // Interface com.sun.star.lang.XInitialization

    // Method of com.sun.star.lang.XInitialization
    virtual void SAL_CALL
    initialize(
      const ::com::sun::star::uno::Sequence< ::com::sun::star::uno::Any >& aArguments )
      throw (
        ::com::sun::star::uno::Exception,
        ::com::sun::star::uno::RuntimeException );

    // XMain methods
    virtual sal_Int32 SAL_CALL run( const ::com::sun::star::uno::Sequence< ::rtl::OUString >& aArguments ) throw (::com::sun::star::uno::RuntimeException);

    // ZInterfaceA methods

    // Methods
    virtual void SAL_CALL setObject( const ::rtl::OUString& objectName )
      throw (::com::sun::star::uno::RuntimeException);
    virtual void SAL_CALL prepareObject(
      const ::rtl::OUString& objectName,
      const ::com::sun::star::uno::Reference< ::com::myco::ZInterfaceAListener >& aListener )
      throw (::com::sun::star::uno::RuntimeException);

  // Additional class member implementations
    StringObjectInfoMap mObjects;

  private:
    // Copy constructor
    ComponentA(const ComponentA & r);

    // Asignment operator
    ComponentA&operator=(ComponentA & r);

    

    // For com.sun.star.lang.XInitialization
    ::osl::Mutex mInitializedMutex;
    ::sal_Bool mInitialized;
  };

} // namespace close


#endif  // ---- INCLUDE PROTECTION ----
