#ifndef _57C6A6F4_FF27_11DC_880A_001CC417AC4A_ // ---- INCLUDE PROTECTION ----
#define _57C6A6F4_FF27_11DC_880A_001CC417AC4A_ // ---- INCLUDE PROTECTION ----
/** 
 ****************************************************************************
 *
 * Service notifying updates
 *
 * @file    ComponentABase.hpp
 *
 * @author  Charles Halliday
 *
 * @date    31 Mar 2008
 *
 ****************************************************************************
 */
#include <cppuhelper/compbase4.hxx>
#include <osl/mutex.hxx>

#include <com/sun/star/uno/Reference.h>
#include <com/sun/star/uno/XComponentContext.hpp>
#include <com/sun/star/lang/XMain.hpp>
#include <com/sun/star/lang/XServiceInfo.hpp>
#include <com/sun/star/uno/RuntimeException.hpp>

#include "com/sun/star/lang/XInitialization.hpp"

#include "com/myco/ZInterfaceA.hpp"

// Enable following line to log service reference counts and
// other component lifecycle information

namespace com_myco_ComponentA {

  class BaseMutex 
  {
  protected:
    mutable ::osl::Mutex mBaseMutex;
  };


  // com.myco.ComponentA base class
  // Implements XMain and XServiceInfo
  typedef ::cppu::WeakComponentImplHelper4<
    ::com::sun::star::lang::XMain
    , ::com::sun::star::lang::XServiceInfo
    , ::com::sun::star::lang::XInitialization
    , ::com::myco::ZInterfaceA
    > ComponentAHelper;


  class ComponentABase :
    public BaseMutex,
    public ComponentAHelper
  {
  public:
    // Constructor
    ComponentABase(
      ::com::sun::star::uno::Reference< ::com::sun::star::uno::XComponentContext > const & xComponentContext);
    
    // Destructor
    virtual ~ComponentABase() = 0;

    // XComponent
    virtual void SAL_CALL dispose(  )
      throw (::com::sun::star::uno::RuntimeException);

    // XMain methods
    virtual sal_Int32 SAL_CALL run( const ::com::sun::star::uno::Sequence< ::rtl::OUString >& aArguments ) throw (::com::sun::star::uno::RuntimeException);

    // XServiceInfo methods
    virtual ::rtl::OUString SAL_CALL getImplementationName(  ) throw (::com::sun::star::uno::RuntimeException);
    virtual sal_Bool SAL_CALL supportsService( const ::rtl::OUString& ServiceName ) throw (::com::sun::star::uno::RuntimeException);
    virtual ::com::sun::star::uno::Sequence< ::rtl::OUString > SAL_CALL getSupportedServiceNames(  ) throw (::com::sun::star::uno::RuntimeException);

  private:
   
  };

} // namespace close


#endif  // ---- INCLUDE PROTECTION ----
