#ifndef _584BEAD0_FF27_11DC_9F60_001CC417AC4A_ // ---- INCLUDE PROTECTION ----
#define _584BEAD0_FF27_11DC_9F60_001CC417AC4A_ // ---- INCLUDE PROTECTION ----
/** 
 ****************************************************************************
 *
 *
 * @file    TestComponentA.hpp
 *
 * @author  Charles Halliday
 *
 * @date    31 Mar 2008
 *
 ****************************************************************************
 */

#include "TestComponentABase.hpp"
#include <iostream>

#define DO_DEBUG_LOGS 0
#define DEBUG_LOG(str) \
 { \
   if ( DO_DEBUG_LOGS ) { \
     std::cerr << "DEBUG: TestComponentA " << getpid() << " " \
               << __FUNCTION__ << "(" << __LINE__ << "): " \
               << str << std::endl; \
   } \
 }
#define DO_INFO_LOGS 1
#define INFO_LOG(str) \
 { \
   if ( DO_INFO_LOGS ) { \
     std::cerr << "INFO: TestComponentA " << getpid() << " " \
               << __FUNCTION__ << "(" << __LINE__ << "): " \
               << str << std::endl; \
   } \
 }
#define DO_ERROR_LOGS 1
#define ERROR_LOG(str) \
 { \
   if ( DO_ERROR_LOGS ) { \
     std::cerr << "ERROR: TestComponentA " << getpid() << " " \
               << __FUNCTION__ << "(" << __LINE__ << "): " \
               << str << std::endl; \
   } \
 }

namespace com_myco_TestComponentA {

  class TestComponentA : public TestComponentABase
  {

  public:

    TestComponentA( ::com::sun::star::uno::Reference< ::com::sun::star::uno::XComponentContext > const & xComponentContext);

    virtual ~TestComponentA();

    // Interface com.sun.star.lang.XInitialization

    // Method of com.sun.star.lang.XInitialization
    virtual void SAL_CALL
    initialize(
      const ::com::sun::star::uno::Sequence< ::com::sun::star::uno::Any >& aArguments )
      throw (
        ::com::sun::star::uno::Exception,
        ::com::sun::star::uno::RuntimeException );

    // XMain methods
    virtual sal_Int32 SAL_CALL run( const ::com::sun::star::uno::Sequence< ::rtl::OUString >& aArguments ) throw (::com::sun::star::uno::RuntimeException);

    // Others
    sal_Bool getArgs(
      const ::com::sun::star::uno::Sequence< ::rtl::OUString >& aArgs )
      throw (::com::sun::star::uno::RuntimeException);

    ::com::sun::star::uno::Reference< ::com::sun::star::uno::XComponentContext > const mComponentContext;
    sal_Int32        mPort;
    ::rtl::OUString  mPortAsString;
    sal_Int32        mNumberOfIterations;
    ::rtl::OUString  mUnoObject;

  private:
    // Copy constructor
    TestComponentA(const TestComponentA & r);

    // Asignment operator
    TestComponentA&operator=(TestComponentA & r);

    // For com.sun.star.lang.XInitialization
    ::osl::Mutex mInitializedMutex;
    ::sal_Bool mInitialized;
  };

} // namespace close


#endif  // ---- INCLUDE PROTECTION ----
