#!/bin/ksh

uname -r | grep -v -q 'el5$'
RHEL5=$?
echo RHEL5=$RHEL5
toolDir=$(dirname $(readlink -f $0) )
PRJ=$(dirname $toolDir)
if [ $RHEL5 ] ; then
  BASE=$PRJ/out.el5
else
  BASE=$PRJ/out
fi
optN=1
optLocal=""
while [ $# -gt 0 ] ; do
  case $1 in
    (-local) optLocal=$1 ;;
    (-n)     shift; optN=$1 ;;
    (*)      echo "Unexpected option: $1" ;;
  esac
  shift
done

OBJECTID=ComponentA
PORT=8100

echo BASE=$BASE
URE_RDB_DIR=${OO_SDK_URE_HOME}/share/misc

UNORC_FILE=$BASE/unorc
cat > $UNORC_FILE <<EOF 
[Bootstrap]
UNO_TYPES= file://${URE_RDB_DIR}/types.rdb file://$BASE/bin/ComponentA.uno.rdb
UNO_SERVICES= file://$BASE/bin/ComponentA.uno.rdb  file://${URE_RDB_DIR}/services.rdb
EOF
#UNO_SERVICES= file://${URE_RDB_DIR}/services.rdb file://$BASE/bin/ComponentA.uno.rdb

LD_LIBRARY_PATH=$BASE/lib:$LD_LIBRARY_PATH

# Start ComponentA service, if remote connection
servicePid=0;
if [ -z "$optLocal" -a -n "" ] ; then
  unoCmd="uno -s com.myco.ComponentA \
      -ro ${URE_RDB_DIR}/types.rdb \
      -ro $BASE/bin/ComponentA.uno.rdb \
      -ro ${URE_RDB_DIR}/services.rdb \
      -u uno:socket,host=0,port=${PORT};urp;ComponentA \
      --singleinstance"
  echo "unoCmd=$unoCmd"
  $unoCmd &
  servicePid=$!
fi

#LD_DEBUG=all
$BASE/bin/stressComponentAClient \
  -unorc file://$UNORC_FILE \
  -n $optN \
  -port $PORT \
  $optLocal

if [ $servicePid -ne 0 ] ; then
  kill $servicePid
  true
fi
