#!/bin/ksh

toolDir=$(dirname $(readlink -f $0) )
PRJ=$(dirname $toolDir)
RHEL5=$(uname -r | grep -q 'el5$' ; echo $? )
if [ "$RHEL5" = "0" ] ; then
  BASE=$PRJ/out.el5
else
  BASE=$PRJ/out
fi
#echo "RHEL5=$RHEL5"
echo "BASE=$BASE"
OBJECTID=ComponentA
PORT=8100
ITERATIONS=1
while [ $# -gt 0 ] ; do
  case $1 in
    (-port) shift; PORT=$1 ;;
    (-n)    shift; ITERATIONS=$1 ;;
    (*)     echo "Unexpected option: $1" ;;
  esac
  shift;
done


LD_LIBRARY_PATH=$BASE/lib:$LD_LIBRARY_PATH

# Run ComponentA as service
#LD_DEBUG=all
#strace -o ./ComponentA.strace.txt -tt 
uno \
  -s com.myco.ComponentA \
  -ro $OO_SDK_URE_HOME/share/misc/types.rdb \
  -ro $OO_SDK_URE_HOME/share/misc/services.rdb \
  -ro $BASE/bin/ComponentA.uno.rdb \
  --quiet \
  -u "uno:socket,host=0,port=$PORT;urp;$OBJECTID" 2>&1 &
serverPid=$!
sleep 1

#Run TestComponentA as client
#LD_DEBUG=all
uno \
  -s com.myco.TestComponentA \
  -ro $OO_SDK_URE_HOME/share/misc/types.rdb \
  -ro $OO_SDK_URE_HOME/share/misc/services.rdb \
  -ro $BASE/bin/TestComponentA.uno.rdb \
  -ro $BASE/bin/ComponentA.uno.rdb \
  -- \
  -n $ITERATIONS \
  -port $PORT 2>&1


kill $serverPid
